﻿using System;
using DevExpress.ExpressApp;
using DevExpress.ExpressApp.DC;
using System.Collections.Generic;
using DevExpress.ExpressApp.Updating;
using DevExpress.ExpressApp.Xpo;
using NumeratorTestProject.Module.BusinessObjects;
using Xafari.BC.Numerators;

namespace NumeratorTestProject.Module
{
	// For more typical usage scenarios, be sure to check out https://docs.devexpress.com/eXpressAppFramework/DevExpress.ExpressApp.ModuleBase.
	public sealed partial class NumeratorTestProjectModule : ModuleBase {
        public NumeratorTestProjectModule() {
            InitializeComponent();
        }
        public override IEnumerable<ModuleUpdater> GetModuleUpdaters(IObjectSpace objectSpace, Version versionFromDB) {
            ModuleUpdater updater = new DatabaseUpdate.Updater(objectSpace, versionFromDB);
            return new ModuleUpdater[] { updater };
        }
        public override void Setup(XafApplication application) {
            base.Setup(application);
            application.SetupComplete += application_SetupComplete;
            // Manage various aspects of the application UI and behavior at the module level.
        }

        void application_SetupComplete(object sender, EventArgs e)
        {
            var userNumerator = new TestCustomNumerator();
            var numeratorLink = new NumeratorLink(userNumerator, typeof(ItemTest), "TestNumber",0, ApplyNumeratorsStrategy.OnSave);
            NumeratorManager.Instance.AddNumerator(userNumerator);
            NumeratorManager.Instance.AddLink(numeratorLink);
        }
        public override void CustomizeTypesInfo(ITypesInfo typesInfo) {
            base.CustomizeTypesInfo(typesInfo);
            CalculatedPersistentAliasHelper.CustomizeTypesInfo(typesInfo);
        }
    }
}
